3 . `dirname "$(readlink -f "$0")"`/run-library.sh
4 . `dirname "$(readlink -f "$0")"`/libcloud-pin
6 read -rd "\000" helpmessage <<EOF
7 $(basename $0): Build Arvados packages
10 WORKSPACE=/path/to/arvados $(basename $0) [options]
14 --build-bundle-packages (default: false)
15 Build api server and workbench packages with vendor/bundle included
17 Output debug information (default: false)
19 Distribution to build packages for (default: debian7)
21 Build command to execute (defaults to the run command defined in the
24 WORKSPACE=path Path to the Arvados source tree to build packages from
29 DEBUG=${ARVADOS_DEBUG:-0}
33 PARSEDOPTS=$(getopt --name "$0" --longoptions \
34 help,build-bundle-packages,debug,target: \
40 eval set -- "$PARSEDOPTS"
41 while [ $# -gt 0 ]; do
44 echo >&2 "$helpmessage"
59 echo >&2 "$0: unrecognized argument '$2'. Try: $0 --help"
67 if [[ "$COMMAND" != "" ]]; then
68 COMMAND="/usr/local/rvm/bin/rvm-exec default bash /jenkins/$COMMAND --target $TARGET"
71 STDOUT_IF_DEBUG=/dev/null
72 STDERR_IF_DEBUG=/dev/null
74 if [[ "$DEBUG" != 0 ]]; then
75 STDOUT_IF_DEBUG=/dev/stdout
76 STDERR_IF_DEBUG=/dev/stderr
80 declare -a PYTHON_BACKPORTS PYTHON3_BACKPORTS
83 PYTHON3_VERSION=$(python3 -c 'import sys; print("{v.major}.{v.minor}".format(v=sys.version_info))')
88 PYTHON2_PACKAGE=python$PYTHON2_VERSION
89 PYTHON2_PKG_PREFIX=python
90 PYTHON3_PACKAGE=python$PYTHON3_VERSION
91 PYTHON3_PKG_PREFIX=python3
92 PYTHON_BACKPORTS=(python-gflags pyvcf google-api-python-client \
93 oauth2client pyasn1==0.1.7 pyasn1-modules==0.0.5 \
94 rsa uritemplate httplib2 ws4py pykka six pyexecjs jsonschema \
95 ciso8601 pycrypto backports.ssl_match_hostname llfuse \
97 PYTHON3_BACKPORTS=(docker-py six requests websocket-client)
101 PYTHON2_PACKAGE=python$PYTHON2_VERSION
102 PYTHON2_PKG_PREFIX=python
103 PYTHON3_PACKAGE=python$PYTHON3_VERSION
104 PYTHON3_PKG_PREFIX=python3
105 PYTHON_BACKPORTS=(python-gflags pyvcf google-api-python-client \
106 oauth2client pyasn1==0.1.7 pyasn1-modules==0.0.5 \
107 rsa uritemplate httplib2 ws4py pykka six pyexecjs jsonschema \
108 ciso8601 pycrypto backports.ssl_match_hostname llfuse \
110 PYTHON3_BACKPORTS=(docker-py six requests websocket-client)
114 PYTHON2_PACKAGE=python$PYTHON2_VERSION
115 PYTHON2_PKG_PREFIX=python
116 PYTHON3_PACKAGE=python$PYTHON3_VERSION
117 PYTHON3_PKG_PREFIX=python3
118 PYTHON_BACKPORTS=(python-gflags pyvcf google-api-python-client \
119 oauth2client pyasn1==0.1.7 pyasn1-modules==0.0.5 \
120 rsa uritemplate httplib2 ws4py pykka six pyexecjs jsonschema \
121 ciso8601 pycrypto backports.ssl_match_hostname llfuse \
123 PYTHON3_BACKPORTS=(docker-py six requests websocket-client)
127 PYTHON2_PACKAGE=python$PYTHON2_VERSION
128 PYTHON2_PKG_PREFIX=python
129 PYTHON3_PACKAGE=python$PYTHON3_VERSION
130 PYTHON3_PKG_PREFIX=python3
131 PYTHON_BACKPORTS=(pyasn1==0.1.7 pyvcf pyasn1-modules==0.0.5 llfuse ciso8601 \
132 google-api-python-client six uritemplate oauth2client httplib2 \
133 rsa 'pycurl<7.21.5' backports.ssl_match_hostname)
134 PYTHON3_BACKPORTS=(docker-py requests websocket-client)
138 PYTHON2_PACKAGE=$(rpm -qf "$(which python$PYTHON2_VERSION)" --queryformat '%{NAME}\n')
139 PYTHON2_PKG_PREFIX=$PYTHON2_PACKAGE
140 PYTHON3_PACKAGE=$(rpm -qf "$(which python$PYTHON3_VERSION)" --queryformat '%{NAME}\n')
141 PYTHON3_PKG_PREFIX=$PYTHON3_PACKAGE
142 PYTHON_BACKPORTS=(python-gflags pyvcf google-api-python-client \
143 oauth2client pyasn1==0.1.7 pyasn1-modules==0.0.5 \
144 rsa uritemplate httplib2 ws4py pykka six pyexecjs jsonschema \
145 ciso8601 pycrypto backports.ssl_match_hostname 'pycurl<7.21.5' \
146 python-daemon lockfile llfuse 'pbr<1.0')
147 PYTHON3_BACKPORTS=(docker-py six requests websocket-client)
148 export PYCURL_SSL_LIBRARY=nss
151 echo -e "$0: Unknown target '$TARGET'.\n" >&2
157 if ! [[ -n "$WORKSPACE" ]]; then
158 echo >&2 "$helpmessage"
160 echo >&2 "Error: WORKSPACE environment variable not set"
166 fpm --version >/dev/null 2>&1
168 if [[ "$?" != 0 ]]; then
169 echo >&2 "$helpmessage"
171 echo >&2 "Error: fpm not found"
176 EASY_INSTALL2=$(find_easy_install -$PYTHON2_VERSION "")
177 EASY_INSTALL3=$(find_easy_install -$PYTHON3_VERSION 3)
179 RUN_BUILD_PACKAGES_PATH="`dirname \"$0\"`"
180 RUN_BUILD_PACKAGES_PATH="`( cd \"$RUN_BUILD_PACKAGES_PATH\" && pwd )`" # absolutized and normalized
181 if [ -z "$RUN_BUILD_PACKAGES_PATH" ] ; then
182 # error; for some reason, the path is not accessible
183 # to the script (e.g. permissions re-evaled after suid)
187 debug_echo "$0 is running from $RUN_BUILD_PACKAGES_PATH"
188 debug_echo "Workspace is $WORKSPACE"
190 if [[ -f /etc/profile.d/rvm.sh ]]; then
191 source /etc/profile.d/rvm.sh
192 GEM="rvm-exec default gem"
197 # Make all files world-readable -- jenkins runs with umask 027, and has checked
198 # out our git tree here
199 chmod o+r "$WORKSPACE" -R
201 # More cleanup - make sure all executables that we'll package are 755
202 find -type d -name 'bin' |xargs -I {} find {} -type f |xargs -I {} chmod 755 {}
204 # Now fix our umask to something better suited to building and publishing
208 debug_echo "umask is" `umask`
210 if [[ ! -d "$WORKSPACE/packages/$TARGET" ]]; then
211 mkdir -p $WORKSPACE/packages/$TARGET
215 debug_echo -e "\nPerl packages\n"
217 cd "$WORKSPACE/sdk/perl"
219 if [[ -e Makefile ]]; then
220 make realclean >"$STDOUT_IF_DEBUG"
222 find -maxdepth 1 \( -name 'MANIFEST*' -or -name "libarvados-perl*.$FORMAT" \) \
226 perl Makefile.PL INSTALL_BASE=install >"$STDOUT_IF_DEBUG" && \
227 make install INSTALLDIRS=perl >"$STDOUT_IF_DEBUG" && \
228 fpm_build install/lib/=/usr/share libarvados-perl \
229 "Curoverse, Inc." dir "$(version_from_git)" install/man/=/usr/share/man \
230 "$WORKSPACE/LICENSE-2.0.txt=/usr/share/doc/libarvados-perl/LICENSE-2.0.txt" && \
231 mv --no-clobber libarvados-perl*.$FORMAT "$WORKSPACE/packages/$TARGET/"
234 debug_echo -e "\nRuby gems\n"
236 FPM_GEM_PREFIX=$($GEM environment gemdir)
238 cd "$WORKSPACE/sdk/ruby"
239 handle_ruby_gem arvados
241 cd "$WORKSPACE/sdk/cli"
242 handle_ruby_gem arvados-cli
244 cd "$WORKSPACE/services/login-sync"
245 handle_ruby_gem arvados-login-sync
248 debug_echo -e "\nPython packages\n"
250 cd "$WORKSPACE/sdk/pam"
251 handle_python_package
253 cd "$WORKSPACE/sdk/python"
254 handle_python_package
256 cd "$WORKSPACE/sdk/cwl"
257 handle_python_package
259 cd "$WORKSPACE/services/fuse"
260 handle_python_package
262 cd "$WORKSPACE/services/nodemanager"
263 handle_python_package
270 COMMIT_HASH=$(format_last_commit_here "%H")
272 SRC_BUILD_DIR=$(mktemp -d)
273 # mktemp creates the directory with 0700 permissions by default
274 chmod 755 $SRC_BUILD_DIR
275 git clone $DASHQ_UNLESS_DEBUG "$WORKSPACE/.git" "$SRC_BUILD_DIR"
278 # go into detached-head state
279 git checkout $DASHQ_UNLESS_DEBUG "$COMMIT_HASH"
280 echo "$COMMIT_HASH" >git-commit.version
283 PKG_VERSION=$(version_from_git)
284 cd $WORKSPACE/packages/$TARGET
285 fpm_build $SRC_BUILD_DIR/=/usr/local/arvados/src arvados-src 'Curoverse, Inc.' 'dir' "$PKG_VERSION" "--exclude=usr/local/arvados/src/.git" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=The Arvados source code" "--architecture=all"
287 rm -rf "$SRC_BUILD_DIR"
291 export GOPATH=$(mktemp -d)
292 package_go_binary services/keepstore keepstore \
293 "Keep storage daemon, accessible to clients on the LAN"
294 package_go_binary services/keepproxy keepproxy \
295 "Make a Keep cluster accessible to clients that are not on the LAN"
296 package_go_binary services/keep-web keep-web \
297 "Static web hosting service for user data stored in Arvados Keep"
298 package_go_binary services/datamanager arvados-data-manager \
299 "Ensure block replication levels, report disk usage, and determine which blocks should be deleted when space is needed"
300 package_go_binary services/arv-git-httpd arvados-git-httpd \
301 "Provide authenticated http access to Arvados-hosted git repositories"
302 package_go_binary services/crunchstat crunchstat \
303 "Gather cpu/memory/network statistics of running Crunch jobs"
304 package_go_binary tools/keep-rsync keep-rsync \
305 "Copy all data from one set of Keep servers to another"
308 # Please resist the temptation to add --no-python-fix-name to the fpm call here
309 # (which would remove the python- prefix from the package name), because this
310 # package is a dependency of arvados-fuse, and fpm can not omit the python-
311 # prefix from only one of the dependencies of a package... Maybe I could
312 # whip up a patch and send it upstream, but that will be for another day. Ward,
314 cd $WORKSPACE/packages/$TARGET
315 rm -rf "$WORKSPACE/sdk/python/build"
316 fpm_build $WORKSPACE/sdk/python "${PYTHON2_PKG_PREFIX}-arvados-python-client" 'Curoverse, Inc.' 'python' "$(awk '($1 == "Version:"){print $2}' $WORKSPACE/sdk/python/arvados_python_client.egg-info/PKG-INFO)" "--url=https://arvados.org" "--description=The Arvados Python SDK" --deb-recommends=git
319 if [[ $TARGET =~ debian|ubuntu ]]; then
320 cd $WORKSPACE/packages/$TARGET
321 rm -rf "$WORKSPACE/sdk/pam/build"
322 fpm_build $WORKSPACE/sdk/pam libpam-arvados 'Curoverse, Inc.' 'python' "$(awk '($1 == "Version:"){print $2}' $WORKSPACE/sdk/pam/arvados_pam.egg-info/PKG-INFO)" "--url=https://arvados.org" "--description=PAM module for authenticating shell logins using Arvados API tokens" --depends libpam-python
326 # Please see comment about --no-python-fix-name above; we stay consistent and do
327 # not omit the python- prefix first.
328 cd $WORKSPACE/packages/$TARGET
329 rm -rf "$WORKSPACE/services/fuse/build"
330 fpm_build $WORKSPACE/services/fuse "${PYTHON2_PKG_PREFIX}-arvados-fuse" 'Curoverse, Inc.' 'python' "$(awk '($1 == "Version:"){print $2}' $WORKSPACE/services/fuse/arvados_fuse.egg-info/PKG-INFO)" "--url=https://arvados.org" "--description=The Keep FUSE driver"
333 cd $WORKSPACE/packages/$TARGET
334 rm -rf "$WORKSPACE/services/nodemanager/build"
335 fpm_build $WORKSPACE/services/nodemanager arvados-node-manager 'Curoverse, Inc.' 'python' "$(awk '($1 == "Version:"){print $2}' $WORKSPACE/services/nodemanager/arvados_node_manager.egg-info/PKG-INFO)" "--url=https://arvados.org" "--description=The Arvados node manager"
337 # The Docker image cleaner
338 cd $WORKSPACE/packages/$TARGET
339 rm -rf "$WORKSPACE/services/dockercleaner/build"
340 fpm_build $WORKSPACE/services/dockercleaner arvados-docker-cleaner 'Curoverse, Inc.' 'python3' "$(awk '($1 == "Version:"){print $2}' $WORKSPACE/services/dockercleaner/arvados_docker_cleaner.egg-info/PKG-INFO)" "--url=https://arvados.org" "--description=The Arvados Docker image cleaner"
343 LIBCLOUD_DIR=$(mktemp -d)
346 git clone $DASHQ_UNLESS_DEBUG https://github.com/curoverse/libcloud.git .
347 git checkout apache-libcloud-$LIBCLOUD_PIN
348 # libcloud is absurdly noisy without -q, so force -q here
349 OLD_DASHQ_UNLESS_DEBUG=$DASHQ_UNLESS_DEBUG
350 DASHQ_UNLESS_DEBUG=-q
351 handle_python_package
352 DASHQ_UNLESS_DEBUG=$OLD_DASHQ_UNLESS_DEBUG
354 fpm_build $LIBCLOUD_DIR "$PYTHON2_PKG_PREFIX"-apache-libcloud
357 # Python 2 dependencies
358 declare -a PIP_DOWNLOAD_SWITCHES=(--no-deps)
359 # Add --no-use-wheel if this pip knows it.
360 pip wheel --help >/dev/null 2>&1
362 0) PIP_DOWNLOAD_SWITCHES+=(--no-use-wheel) ;;
364 *) echo "WARNING: `pip wheel` test returned unknown exit code $?" ;;
367 for deppkg in "${PYTHON_BACKPORTS[@]}"; do
368 outname=$(echo "$deppkg" | sed -e 's/^python-//' -e 's/[<=>].*//' -e 's/_/-/g' -e "s/^/${PYTHON2_PKG_PREFIX}-/")
370 httplib2|google-api-python-client)
371 # Work around 0640 permissions on some package files.
372 # See #7591 and #7991.
373 pyfpm_workdir=$(mktemp --tmpdir -d pyfpm-XXXXXX) && (
376 pip install "${PIP_DOWNLOAD_SWITCHES[@]}" --download . "$deppkg"
377 tar -xf "$deppkg"-*.tar*
379 "python$PYTHON2_VERSION" setup.py $DASHQ_UNLESS_DEBUG egg_info build
382 # --iteration 2 provides an upgrade for previously built
384 fpm_build . "$outname" "" python "" --iteration 2
385 # The upload step uses the package timestamp to determine
386 # whether it's new. --no-clobber plays nice with that.
387 mv --no-clobber "$outname"*.$FORMAT "$WORKSPACE/packages/$TARGET"
389 if [ 0 != "$?" ]; then
390 echo "ERROR: $deppkg build process failed"
393 if [ -n "$pyfpm_workdir" ]; then
394 rm -rf "$pyfpm_workdir"
398 fpm_build "$deppkg" "$outname"
403 # Python 3 dependencies
404 for deppkg in "${PYTHON3_BACKPORTS[@]}"; do
405 outname=$(echo "$deppkg" | sed -e 's/^python-//' -e 's/[<=>].*//' -e 's/_/-/g' -e "s/^/${PYTHON3_PKG_PREFIX}-/")
406 # The empty string is the vendor argument: these aren't Curoverse software.
407 fpm_build "$deppkg" "$outname" "" python3
410 # Build the API server package
411 handle_rails_package arvados-api-server "$WORKSPACE/services/api" \
412 "$WORKSPACE/agpl-3.0.txt" --url="https://arvados.org" \
413 --description="Arvados API server - Arvados is a free and open source platform for big data science." \
414 --license="GNU Affero General Public License, version 3.0"
416 # Build the workbench server package
419 cd "$WORKSPACE/apps/workbench"
421 # We need to bundle to be ready even when we build a package without vendor directory
422 # because asset compilation requires it.
423 bundle install --path vendor/bundle >"$STDOUT_IF_DEBUG"
425 # clear the tmp directory; the asset generation step will recreate tmp/cache/assets,
426 # and we want that in the package, so it's easier to not exclude the tmp directory
427 # from the package - empty it instead.
431 # Set up application.yml and production.rb so that asset precompilation works
432 \cp config/application.yml.example config/application.yml -f
433 \cp config/environments/production.rb.example config/environments/production.rb -f
434 sed -i 's/secret_token: ~/secret_token: xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx/' config/application.yml
436 RAILS_ENV=production RAILS_GROUPS=assets bundle exec rake assets:precompile >/dev/null
438 # Remove generated configuration files so they don't go in the package.
439 rm config/application.yml config/environments/production.rb
442 if [[ "$?" != "0" ]]; then
443 echo "ERROR: Asset precompilation failed"
446 handle_rails_package arvados-workbench "$WORKSPACE/apps/workbench" \
447 "$WORKSPACE/agpl-3.0.txt" --url="https://arvados.org" \
448 --description="Arvados Workbench - Arvados is a free and open source platform for big data science." \
449 --license="GNU Affero General Public License, version 3.0"
452 # clean up temporary GOPATH